// $ANTLR 2.7.2: "game.g" -> "P.java"$

	package grammar;
	import signalgame.*;
	import signalgame.instancebased.*;
	import math.*;
	import java.util.*;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

public class P extends antlr.LLkParser       implements PTokenTypes
 {

protected P(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public P(TokenBuffer tokenBuf) {
  this(tokenBuf,1);
}

protected P(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public P(TokenStream lexer) {
  this(lexer,1);
}

public P(ParserSharedInputState state) {
  super(state,1);
  tokenNames = _tokenNames;
}

	public final StaticInformation  game() throws RecognitionException, TokenStreamException {
		StaticInformation si;
		
		
			si = null;
			FiniteSet 				states, messages, actions, reputations;
			ReputationPayoffMatrix 	pu, pm;
			ProbabilityDistribution Pt;
			double					correlation;
			Mutator					mutation;
			double 					mr;
			PopulationType 			pop;
			
			double [][][][][] uc, um;
			double [] pt;
			
		
		
		try {      // for error handling
			{
			match(LITERAL_game);
			match(OPEN);
			match(LITERAL_states);
			match(IS);
			states=finiteset();
			match(SEMICOL);
			match(LITERAL_messages);
			match(IS);
			messages=finiteset();
			match(SEMICOL);
			match(LITERAL_actions);
			match(IS);
			actions=finiteset();
			match(SEMICOL);
			match(LITERAL_reputations);
			match(IS);
			reputations=finiteset();
			match(SEMICOL);
			match(LITERAL_mutator);
			match(IS);
			mutation=mutator();
			match(SEMICOL);
			match(LITERAL_mutationrate);
			match(IS);
			mr=doublev();
			match(SEMICOL);
			match(LITERAL_correlation);
			match(IS);
			correlation=doublev();
			match(SEMICOL);
			{
			match(LITERAL_P_states);
			match(IS);
			pt=doublearray1();
			match(SEMICOL);
			Pt = new ProbabilityDistribution(states, pt);
			}
			{
			match(LITERAL_utility_communication);
			match(IS);
			uc=doublearray5();
			match(SEMICOL);
			pu = new ReputationPayoffMatrix(reputations,states,actions,uc);
			}
			{
			match(LITERAL_utility_message);
			match(IS);
			um=doublearray5();
			match(SEMICOL);
			pm = new ReputationPayoffMatrix(reputations,states,messages,um);
			}
			match(LITERAL_population);
			pop=population();
			match(CLOSE);
			}
			
						si = new InstanceBasedStatic(
							states, 
							messages, 
							actions,
							reputations,
							Pt,
							pu, 
							pm,
							pop,
							mutation,
							mr,
							correlation);
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
		return si;
	}
	
	public final FiniteSet  finiteset() throws RecognitionException, TokenStreamException {
		FiniteSet s;
		
		
			s = null;
			Vector v = new Vector();
			String i;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop9:
			do {
				if ((LA(1)==ID)) {
					i=identifier();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case CLOSE:
					case ID:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(i);
				}
				else {
					break _loop9;
				}
				
			} while (true);
			}
			match(CLOSE);
			s = new FiniteSet(v.toArray());
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return s;
	}
	
	public final Mutator  mutator() throws RecognitionException, TokenStreamException {
		Mutator mutator;
		
		
			mutator = null;
			double v;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_identity:
			{
				match(LITERAL_identity);
				match(OPEN);
				match(CLOSE);
				mutator = new IdentityMutator();
				break;
			}
			case LITERAL_fairshare:
			{
				match(LITERAL_fairshare);
				match(OPEN);
				v=doublev();
				match(CLOSE);
				mutator = new FairShareMutator(v);
				break;
			}
			case LITERAL_unfairshare:
			{
				match(LITERAL_unfairshare);
				match(OPEN);
				v=doublev();
				match(CLOSE);
				mutator = new UnfairShareMutator(v);
				break;
			}
			case LITERAL_exchange:
			{
				match(LITERAL_exchange);
				match(OPEN);
				match(CLOSE);
				mutator = new ExchangeMutator();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return mutator;
	}
	
	public final double  doublev() throws RecognitionException, TokenStreamException {
		double d;
		
		Token  x = null;
		Token  y = null;
		Token  z = null;
		
			d = 	0;
			String s = "";
		
		
		try {      // for error handling
			{
			int _cnt55=0;
			_loop55:
			do {
				if ((LA(1)==DIGIT)) {
					x = LT(1);
					match(DIGIT);
					s+=x.getText();
				}
				else {
					if ( _cnt55>=1 ) { break _loop55; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt55++;
			} while (true);
			}
			{
			switch ( LA(1)) {
			case PERIOD:
			{
				y = LT(1);
				match(PERIOD);
				s+=y.getText();
				{
				int _cnt58=0;
				_loop58:
				do {
					if ((LA(1)==DIGIT)) {
						z = LT(1);
						match(DIGIT);
						s+=z.getText();
					}
					else {
						if ( _cnt58>=1 ) { break _loop58; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt58++;
				} while (true);
				}
				break;
			}
			case SEMICOL:
			case CLOSE:
			case COMMA:
			case DIGIT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			d = Double.parseDouble(s);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_2);
		}
		return d;
	}
	
	public final double []  doublearray1() throws RecognitionException, TokenStreamException {
		double [] x;
		
		
			x = null;
			double d;
			Vector v = new Vector();
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop13:
			do {
				if ((LA(1)==DIGIT)) {
					d=doublev();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case CLOSE:
					case DIGIT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(new Double(d));
				}
				else {
					break _loop13;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							x = new double[v.size()];
							for (int i = 0; i < x.length; i++)
							{
								x[i] = ((Double)v.elementAt(i)).doubleValue();
							}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_3);
		}
		return x;
	}
	
	public final double [][][][][]  doublearray5() throws RecognitionException, TokenStreamException {
		double [][][][][] x;
		
		
			x = null;
			Vector v = new Vector();
			double [][][][] a;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop29:
			do {
				if ((LA(1)==OPEN)) {
					a=doublearray4();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case OPEN:
					case CLOSE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(a);
				}
				else {
					break _loop29;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							x = new double[v.size()][][][][];
							for (int i = 0; i < x.length; i++)
							{
								x[i] = (double [][][][])v.elementAt(i);
							}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_1);
		}
		return x;
	}
	
	public final  PopulationType  population() throws RecognitionException, TokenStreamException {
		 PopulationType pt ;
		
		
			pt = null;
			Vector v = new Vector();
			IndividualType it;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop32:
			do {
				if ((LA(1)==LITERAL_individual)) {
					it=individualtype();
					v.add(it);
				}
				else {
					break _loop32;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							IndividualType [] is = new IndividualType[v.size()];
							for (int i = 0; i < is.length; i++)
							{
								is[i] = (IndividualType)v.elementAt(i);
							}
							
							pt = new PopulationType(is);
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
		return pt ;
	}
	
	public final String  identifier() throws RecognitionException, TokenStreamException {
		String s;
		
		Token  i = null;
		
			s = null;
		
		
		try {      // for error handling
			i = LT(1);
			match(ID);
			s = i.getText();
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_5);
		}
		return s;
	}
	
	public final double [][]  doublearray2() throws RecognitionException, TokenStreamException {
		double [][] x;
		
		
			x = null;
			Vector v = new Vector();
			double [] a;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop17:
			do {
				if ((LA(1)==OPEN)) {
					a=doublearray1();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case OPEN:
					case CLOSE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(a);
				}
				else {
					break _loop17;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							x = new double[v.size()][];
							for (int i = 0; i < x.length; i++)
							{
								x[i] = (double [])v.elementAt(i);
							}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return x;
	}
	
	public final double [][][]  doublearray3() throws RecognitionException, TokenStreamException {
		double [][][] x;
		
		
			x = null;
			Vector v = new Vector();
			double [][] a;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop21:
			do {
				if ((LA(1)==OPEN)) {
					a=doublearray2();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case OPEN:
					case CLOSE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(a);
				}
				else {
					break _loop21;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							x = new double[v.size()][][];
							for (int i = 0; i < x.length; i++)
							{
								x[i] = (double [][])v.elementAt(i);
							}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return x;
	}
	
	public final double [][][][]  doublearray4() throws RecognitionException, TokenStreamException {
		double [][][][] x;
		
		
			x = null;
			Vector v = new Vector();
			double [][][] a;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop25:
			do {
				if ((LA(1)==OPEN)) {
					a=doublearray3();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case OPEN:
					case CLOSE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(a);
				}
				else {
					break _loop25;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							x = new double[v.size()][][][];
							for (int i = 0; i < x.length; i++)
							{
								x[i] = (double [][][])v.elementAt(i);
							}
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return x;
	}
	
	public final IndividualType  individualtype() throws RecognitionException, TokenStreamException {
		IndividualType it ;
		
		
			it = 						null;
			int             			count;
			boolean         			b;
			ReputationStrategyType    	Ss, Sh;
			String          			reputation;
		
		
		try {      // for error handling
			match(LITERAL_individual);
			match(OPEN);
			count=intv();
			match(COMMA);
			b=evolution();
			match(CLOSE);
			match(OPEN);
			match(LITERAL_speakerstrategy);
			Ss=reputationstrategy();
			match(LITERAL_hearerstrategy);
			Sh=reputationstrategy();
			match(LITERAL_reputation);
			match(OPEN);
			reputation=identifier();
			match(CLOSE);
			match(SEMICOL);
			match(CLOSE);
			
						it = new IndividualType(count, b, Ss, Sh, reputation);
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_7);
		}
		return it ;
	}
	
	public final int  intv() throws RecognitionException, TokenStreamException {
		int i;
		
		Token  x = null;
		
			i = 0;
			String s = "";
		
		
		try {      // for error handling
			{
			int _cnt52=0;
			_loop52:
			do {
				if ((LA(1)==DIGIT)) {
					x = LT(1);
					match(DIGIT);
					s+=x.getText();
				}
				else {
					if ( _cnt52>=1 ) { break _loop52; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt52++;
			} while (true);
			}
			i = Integer.parseInt(s);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return i;
	}
	
	public final boolean  evolution() throws RecognitionException, TokenStreamException {
		boolean b;
		
		
			b = false;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_evolving:
			{
				match(LITERAL_evolving);
				b = true;
				break;
			}
			case LITERAL_fixed:
			{
				match(LITERAL_fixed);
				b = false;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_4);
		}
		return b;
	}
	
	public final  ReputationStrategyType  reputationstrategy() throws RecognitionException, TokenStreamException {
		 ReputationStrategyType rst ;
		
		
			rst = null;
			Vector v = new Vector();
			StrategyType s;
			
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop38:
			do {
				if ((LA(1)==OPEN)) {
					s=strategy();
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case OPEN:
					case CLOSE:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					v.add(s);
				}
				else {
					break _loop38;
				}
				
			} while (true);
			}
			match(CLOSE);
			
						StrategyType [] st = new StrategyType [v.size()];
			
						for (int i = 0; i < st.length; i++)
						{
							st[i] = (StrategyType)v.elementAt(i);
						}
						
						rst = new ReputationStrategyType(st);
					
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_9);
		}
		return rst ;
	}
	
	public final  StrategyType  strategy() throws RecognitionException, TokenStreamException {
		 StrategyType st ;
		
		
			st = null;
			Vector mv = new Vector();
			MappingType m;
		
		
		try {      // for error handling
			match(OPEN);
			{
			_loop41:
			do {
				if ((LA(1)==LITERAL_map)) {
					m=mappingtype();
					mv.add(m);
				}
				else {
					break _loop41;
				}
				
			} while (true);
			}
			match(CLOSE);
			
							MappingType [] ms = new MappingType[mv.size()];
							for (int i = 0; i < ms.length; i++)
							{
								ms[i] = (MappingType)mv.elementAt(i);
							}
							
							st = new StrategyType(ms);
						
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_6);
		}
		return st ;
	}
	
	public final MappingType  mappingtype() throws RecognitionException, TokenStreamException {
		MappingType m;
		
		
			PDFactory 	p = null;
			boolean 	b = false;
			m = null;
			
		
		
		try {      // for error handling
			match(LITERAL_map);
			match(OPEN);
			p=pdf();
			match(COMMA);
			b=evolution();
			match(CLOSE);
			match(SEMICOL);
			m = new MappingType(p,b);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_10);
		}
		return m;
	}
	
	public final PDFactory  pdf() throws RecognitionException, TokenStreamException {
		PDFactory pdf;
		
		
			pdf = null;
			double [] ps;
		
		
		try {      // for error handling
			switch ( LA(1)) {
			case LITERAL_random:
			{
				match(LITERAL_random);
				pdf = new RandomPDF();
				break;
			}
			case LITERAL_justone:
			{
				match(LITERAL_justone);
				pdf = new JustOnePDF();
				break;
			}
			case LITERAL_uniform:
			{
				match(LITERAL_uniform);
				pdf = new UniformPDF();
				break;
			}
			case OPEN:
			{
				ps=doublearray1();
				pdf = new GivenPDF(ps);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_8);
		}
		return pdf;
	}
	
	public final void function() throws RecognitionException, TokenStreamException {
		
		
		try {      // for error handling
			match(ID);
			match(OPEN);
			{
			_loop46:
			do {
				if ((LA(1)==ID)) {
					match(ID);
					{
					switch ( LA(1)) {
					case COMMA:
					{
						match(COMMA);
						break;
					}
					case CLOSE:
					case ID:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
				}
				else {
					break _loop46;
				}
				
			} while (true);
			}
			match(CLOSE);
		}
		catch (RecognitionException ex) {
			reportError(ex);
			consume();
			consumeUntil(_tokenSet_0);
		}
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"game\"",
		"OPEN",
		"\"states\"",
		"IS",
		"SEMICOL",
		"\"messages\"",
		"\"actions\"",
		"\"reputations\"",
		"\"mutator\"",
		"\"mutationrate\"",
		"\"correlation\"",
		"\"P_states\"",
		"\"utility_communication\"",
		"\"utility_message\"",
		"\"population\"",
		"CLOSE",
		"COMMA",
		"\"individual\"",
		"\"speakerstrategy\"",
		"\"hearerstrategy\"",
		"\"reputation\"",
		"\"evolving\"",
		"\"fixed\"",
		"\"map\"",
		"ID",
		"\"random\"",
		"\"justone\"",
		"\"uniform\"",
		"\"identity\"",
		"\"fairshare\"",
		"\"unfairshare\"",
		"\"exchange\"",
		"DIGIT",
		"PERIOD",
		"LETTER",
		"UNDERSCORE",
		"MINUS",
		"WS"
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { 256L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { 68721049856L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { 1573152L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { 524288L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { 270008320L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { 1572896L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 2621440L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { 1048576L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { 25165824L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { 134742016L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	
	}
