package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import signalgame.*;
import signalgame.typebased.*;
import math.*;
import util.Formatter;

/**
 *  @author Project A.I. Development Team
 */

public class GUI_Info extends JPanel
{
    GUI_Function pSs = new GUI_Function();
    TitledBorder titledBorder1;
    TitledBorder titledBorder2;
    TitledBorder titledBorder3;
    JPanel jPanel3 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    GUI_Function pSh = new GUI_Function();
    JTextArea tInformation = new JTextArea();
    BorderLayout borderLayout1 = new BorderLayout();
    GUI_Legend pLegend = new GUI_Legend();

	public GUI_Info()
    {
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }


	private void jbInit() throws Exception
    {
        titledBorder1 = new TitledBorder("");
        titledBorder2 = new TitledBorder("");
        titledBorder3 = new TitledBorder("");
        this.setLayout(borderLayout1);
        pSs.setBorder(titledBorder1);
        titledBorder1.setTitle("Speaker Strategy");
        titledBorder2.setTitle("Hearer Strategy");
        titledBorder3.setTitle("Agent Information");
        jPanel3.setLayout(gridLayout2);
        gridLayout2.setColumns(3);
        pSh.setBorder(titledBorder2);
        tInformation.setEnabled(false);
        tInformation.setFont(new java.awt.Font("Monospaced", 0, 12));
        tInformation.setBorder(titledBorder3);
        tInformation.setRows(10);
        tInformation.setForeground(Color.black);
        tInformation.setDisabledTextColor(Color.black);
        this.add(jPanel3, BorderLayout.CENTER);
        jPanel3.add(pSs, null);
        jPanel3.add(pSh, null);
		jPanel3.add(tInformation, null);
        this.add(pLegend,  BorderLayout.SOUTH);


		setSettings(null, 0);
    }

	public void reset()
	{
		pSs.reset();
		pSh.reset();
	}

	public void setSettings(DynamicInformation di, int i)
	{
		if (di == null)
		{
			pSs.setFunction(null);
			pSh.setFunction(null);
			tInformation.setText("");
			tInformation.setBackground(Color.lightGray);
		}
		else
		{
			IIndividual I = di.I[i];
//		    DiscreteFunction Ss = (DiscreteFunction)e.elements[0];
//			DiscreteFunction Sh = (DiscreteFunction)e.elements[1];

			pSs.setFunction(I.Ss);
			pSh.setFunction(I.Sh);

			final int WL = 25;
			StringBuffer s = new StringBuffer();
			s.append(Formatter.padr("Agent Reputation:", WL));          s.append(di.S.R.elements[di.I[i].reputationID]);    s.append('\n');
			s.append(Formatter.padr("Agent Probability:", WL));         s.append(di.Pi.ps[i]);                              s.append('\n');
			s.append(Formatter.padr("Expected Agent Utility:", WL));    s.append(di.Ei[i]);                                 s.append('\n');
			s.append(Formatter.padr("Expected Total Utility:", WL));    s.append(di.E);

			tInformation.setText(s.toString());
			tInformation.setBackground(Color.white);
		}

	}
}