package gui;

import javax.swing.*;
import java.awt.*;

/**
 *  @author Project A.I. Development Team
 */

public class GUI_Legend extends JPanel
{
	public static final int HEIGHT =    20;

    public GUI_Legend()
    {
		this.setPreferredSize(new Dimension(10, HEIGHT));
    }


	public static Color heat(double fraction)
	{
		assert fraction >= 0.0 && fraction <= 1.0 : "Fraction was: " + fraction;
		return new Color(Color.HSBtoRGB((float)fraction/3.0f, 1.0f, 1.0f));
	}

	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);

		Dimension d = this.getSize();
		if (d.width == 0) return;

		for (int j = 0; j < d.width; j++)
		{
			g.setColor(heat((double)j/d.width));
			g.drawLine(j, 0, j, d.height);
		}
	}
}