package gui;

import java.awt.*;
import javax.swing.*;

/**
 *  @author Project A.I. Development Team
 */

public class GUI_Payoff extends JPanel
{
    GridLayout gridLayout1 = new GridLayout();
    JTextField jTextField1 = new JTextField();
    JTextField jTextField2 = new JTextField();

    public GUI_Payoff()
    {
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

	public GUI_Payoff(double [] values)
	{
		this();
		assert values.length == 2 : "Single Payoff element should be size 2";
		jTextField1.setText(Double.toString(values[0]));
		jTextField2.setText(Double.toString(values[1]));
	}

    private void jbInit() throws Exception
    {
        jTextField1.setAlignmentX(JTextField.CENTER);
        jTextField1.setBorder(null);
        this.setBorder(BorderFactory.createLoweredBevelBorder());
        this.setLayout(gridLayout1);
        gridLayout1.setColumns(2);
        jTextField2.setBorder(null);
        this.add(jTextField1, null);
        this.add(jTextField2, null);

		jTextField1.setHorizontalAlignment(JTextField.CENTER);
		jTextField2.setHorizontalAlignment(JTextField.CENTER);
    }

	public double [] getPayoff()
	{
		return new double []
		{
			Double.parseDouble(jTextField1.getText()),
			Double.parseDouble(jTextField2.getText()),
		};
	}
}