package gui;

import javax.swing.*;
import java.awt.*;

import signalgame.*;
import math.*;

/**
 *  @author Project A.I. Development Team
 */

public class GUI_PayoffMatrix extends JPanel
{
	GUI_Payoff [][] p = new GUI_Payoff[0][0];
	FiniteSet set1, set2;


    public GUI_PayoffMatrix()
    {
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

	private void jbInit() throws Exception
    {
    }

	public void setSets(FiniteSet set1, FiniteSet set2)
	{
		this.removeAll();
		this.set1 = set1;
		this.set2 = set2;

		GUI_Payoff [][] newp = new GUI_Payoff[set1.elements.length][set2.elements.length];

		this.setLayout(new GridLayout(newp.length + 1, newp[0].length + 1));

		// Top left corner label
		this.add(new JLabel(""));

		// Column labels
		for (int c = 0; c < set2.elements.length; c++)
		{
			this.add(new JLabel(set2.elements[c].toString(), JLabel.CENTER));
		}

		// Rows
		for (int r = 0; r < set1.elements.length; r++)
		{
			// Start with a label
			this.add(new JLabel(set1.elements[r].toString(), JLabel.CENTER));

			// Then list the values
			for (int c = 0; c < set2.elements.length; c++)
			{
				// Check if old value existed
				if (r < p.length && c < p[0].length)    newp[r][c] = p[r][c];
				else                                    newp[r][c] = new GUI_Payoff(new double [] {0, 0});
				this.add(newp[r][c]);
			}
		}

		this.p = newp;
	}

	public PayoffMatrix getPayoffMatrix()
	{
		double [][][] v = new double[p.length][p[0].length][];

		for(int r = 0; r < v.length; r++)
		{
			for (int c = 0; c < v[r].length; c++)
			{
				v[r][c] = p[r][c].getPayoff();
			}
		}

		return new PayoffMatrix(set1, set2, v);
	}
}