package gui;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import signalgame.*;
import signalgame.typebased.*;
import math.*;


/**
 *  @author Project A.I. Development Team
 */

public class GUI_Settings extends JDialog implements ChangeListener
{
    TitledBorder titledBorder1;
    TitledBorder titledBorder2;
    TitledBorder titledBorder3;


    BorderLayout borderLayout5 = new BorderLayout();
    JToolBar jToolBar1 = new JToolBar();
    JButton bCancel = new JButton();



	FiniteSet states =      new FiniteSet(new Object[0]);
	FiniteSet messages =    new FiniteSet(new Object[0]);
	FiniteSet actions =     new FiniteSet(new Object[0]);

	FiniteSet       Ss;
	FiniteSet       Sh;
	Individual []   I;

	ProbabilityDistribution Pt;
	ProbabilityDistribution Pi;


	TypeBasedStatic sg;
    TitledBorder titledBorder4;
    TitledBorder titledBorder5;
    TitledBorder titledBorder6;
    JTabbedPane jTabbedPane1 = new JTabbedPane();
    JPanel pOptions1 = new JPanel();
    JPanel jPanel1 = new JPanel();
    JLabel lStates = new JLabel();
    JSlider sStates = new JSlider();
    JLabel lMessages = new JLabel();
    JComboBox cbEvolution = new JComboBox();
    JScrollPane jScrollPane2 = new JScrollPane();
    JPanel pActions = new JPanel();
    JSlider sActions = new JSlider();
    JLabel lActions = new JLabel();
    JSlider sMessages = new JSlider();
    GridLayout gridLayout1 = new GridLayout();
    JPanel pMessages = new JPanel();
    BorderLayout borderLayout4 = new BorderLayout();
    BorderLayout borderLayout3 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    JPanel pStates = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    JPanel pOptions2 = new JPanel();
    GridLayout gridLayout2 = new GridLayout();
    GUI_PayoffMatrix payoff_utility = new GUI_PayoffMatrix();
    GUI_PayoffMatrix payoff_cost = new GUI_PayoffMatrix();
    TitledBorder titledBorder7;
    TitledBorder titledBorder8;
    JPanel jPanel2 = new JPanel();
    JPanel jPanel3 = new JPanel();
    GUI_Probability probability_state = new GUI_Probability();
    GUI_Probability probability_indiv = new GUI_Probability();
    BorderLayout borderLayout6 = new BorderLayout();
    BorderLayout borderLayout7 = new BorderLayout();
    JButton bNext = new JButton();
    JButton bPrev = new JButton();


    public GUI_Settings(Frame parent)
    {
		super(parent, "TypeBased Settings", true);

		this.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				Cancel();
			}
		});

        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

		this.pack();
    }
    private void jbInit() throws Exception
    {
        titledBorder1 = new TitledBorder("");
        titledBorder2 = new TitledBorder("");
        titledBorder3 = new TitledBorder("");
        titledBorder4 = new TitledBorder("");
        titledBorder5 = new TitledBorder("");
        titledBorder6 = new TitledBorder("");
        titledBorder7 = new TitledBorder("");
        titledBorder8 = new TitledBorder("");
        titledBorder1.setTitle("States");
        titledBorder2.setTitle("Messages");
        titledBorder3.setTitle("Actions");
        this.setDefaultCloseOperation(3);
        this.getContentPane().setLayout(borderLayout5);
        bCancel.setText("Cancel");
        bCancel.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                Cancel();
            }
        });



        titledBorder4.setTitle("Communication Utility");
        titledBorder5.setTitle("Evolution Process");
        titledBorder6.setTitle("Message Utility (costs are negative)");
        pOptions1.setLayout(gridLayout1);
        jPanel1.setLayout(borderLayout4);
        jPanel1.setBorder(titledBorder5);
        lStates.setHorizontalAlignment(SwingConstants.CENTER);
        lStates.setText("jLabel1");
        sStates.setMajorTickSpacing(2);
        sStates.setMaximum(10);
        sStates.setMinimum(1);
        sStates.setValue(2);
        sStates.setMinorTickSpacing(1);
        sStates.setPaintLabels(true);
        sStates.setPaintTicks(true);
        sStates.setSnapToTicks(true);
        sStates.addChangeListener(this);
        lMessages.setHorizontalAlignment(SwingConstants.CENTER);
        lMessages.setText("jLabel2");
        pActions.setBorder(titledBorder3);
        pActions.setLayout(borderLayout3);
        sActions.setMajorTickSpacing(2);
        sActions.setMaximum(10);
        sActions.setMinimum(1);
        sActions.setValue(2);
        sActions.setMinorTickSpacing(1);
        sActions.setPaintLabels(true);
        sActions.setPaintTicks(true);
        sActions.setSnapToTicks(true);
        sActions.addChangeListener(this);
        lActions.setHorizontalAlignment(SwingConstants.CENTER);
        lActions.setText("jLabel3");
        sMessages.setMajorTickSpacing(2);
        sMessages.setMaximum(10);
        sMessages.setMinimum(1);
        sMessages.setValue(2);
        sMessages.setMinorTickSpacing(1);
        sMessages.setPaintLabels(true);
        sMessages.setPaintTicks(true);
        sMessages.setSnapToTicks(true);
        sMessages.addChangeListener(this);
        gridLayout1.setColumns(2);
        gridLayout1.setRows(2);
        pMessages.setBorder(titledBorder2);
        pMessages.setLayout(borderLayout2);
        pStates.setBorder(titledBorder1);
        pStates.setLayout(borderLayout1);
        pOptions2.setLayout(gridLayout2);
        gridLayout2.setColumns(2);
        gridLayout2.setRows(2);
        payoff_utility.setBorder(titledBorder4);
        payoff_cost.setBorder(titledBorder6);
        titledBorder7.setTitle("State Probability");
        titledBorder8.setTitle("Individual Probability");
        jPanel3.setBorder(titledBorder7);
        jPanel3.setLayout(borderLayout6);
        jPanel2.setBorder(titledBorder8);
        jPanel2.setLayout(borderLayout7);
        bNext.setText("Next");
        bNext.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                nextTab(e);
            }
        });
        bPrev.setText("Previous");
        bPrev.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {
                prevTab(e);
            }
        });
        jTabbedPane1.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(ChangeEvent e)
            {
                tabSelect(e);
            }
        });
        jToolBar1.add(bPrev, null);
        this.getContentPane().add(jToolBar1,  BorderLayout.SOUTH);
        jToolBar1.add(bNext, null);
        this.getContentPane().add(jTabbedPane1,  BorderLayout.CENTER);
        jTabbedPane1.add(jScrollPane2,  "Settings 1/2");
        jTabbedPane1.add(jScrollPane1,  "Settings 2/2");
        jScrollPane1.getViewport().add(pOptions2, null);
        pOptions2.add(payoff_utility, null);
		pOptions2.add(payoff_cost, null);

        pOptions2.add(jPanel3, null);
        jPanel3.add(probability_state, BorderLayout.CENTER);
        pOptions2.add(jPanel2, null);
        jPanel2.add(probability_indiv, BorderLayout.CENTER);

        jScrollPane2.getViewport().add(pOptions1, null);
        pMessages.add(sMessages, BorderLayout.CENTER);
        pMessages.add(lMessages, BorderLayout.SOUTH);
        pOptions1.add(pStates, null);
        pOptions1.add(pMessages, null);
        pStates.add(sStates, BorderLayout.CENTER);
        pStates.add(lStates, BorderLayout.SOUTH);
        pOptions1.add(pActions, null);
        pActions.add(sActions, BorderLayout.CENTER);
        pActions.add(lActions, BorderLayout.SOUTH);
        pOptions1.add(jPanel1, null);
        jPanel1.add(cbEvolution, BorderLayout.NORTH);
        jToolBar1.add(bCancel, null);

		stateChanged(null);
        cbEvolution.addItem(new IdentityMutator());
		cbEvolution.addItem(new FairShareMutator(0.01));
		cbEvolution.addItem(new UnfairShareMutator(0.01));
		cbEvolution.addItem(new ExchangeMutator());


		cbEvolution.setSelectedIndex(0);
		jTabbedPane1.setSelectedIndex(0);
		tabSelect(null);
    }

	public void changeSettings(int states, int messages, int actions)
	{
		if (this.states.elements.length != states)
		{
			Object [] s = new Object[states];
			for (int i = 0; i < states; i++) s[i] = "s" + i;
			this.states = new FiniteSet(s);
			this.lStates.setText(this.states.toString());
		}

		if (this.messages.elements.length != messages)
		{
			Object [] m = new Object[messages];
			for (int i = 0; i < messages; i++) m[i] = "m" + i;
			this.messages = new FiniteSet(m);
			this.lMessages.setText(this.messages.toString());
		}

		if (this.actions.elements.length != actions)
		{
		    Object [] a = new Object[actions];
			for (int i = 0; i < actions; i++) a[i] = "a" + i;
			this.actions = new FiniteSet(a);
			this.lActions.setText(this.actions.toString());
		}

	}


    public void stateChanged(ChangeEvent e)
    {
		this.changeSettings(sStates.getValue(),
							sMessages.getValue(),
							sActions.getValue());
    }

	public TypeBasedStatic getTypeBasedStatic()
	{
		this.sg = null;
		this.setLocationRelativeTo(this.getOwner());
		this.jTabbedPane1.setSelectedIndex(0);
		this.setVisible(true);
		return sg;
	}

    void OK()
    {
		try
		{
			FiniteSet reputations = new FiniteSet(new Object [] {"default"});

			ReputationPayoffMatrix ru = new ReputationPayoffMatrix(reputations, states,     messages,   new double [][][][][]{{payoff_utility.  getPayoffMatrix().values}});
			ReputationPayoffMatrix rc = new ReputationPayoffMatrix(reputations, messages,   actions,    new double [][][][][]{{payoff_cost.     getPayoffMatrix().values}});



			sg = new TypeBasedStatic(  states, messages, actions, reputations, I,
									   probability_state.getProbabilityDistribution(),
									   probability_indiv.getProbabilityDistribution(),
									   ru, rc,
									   (Mutator)cbEvolution.getSelectedItem());
			this.setVisible(false);
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, ex, "Error", JOptionPane.ERROR_MESSAGE);
		}
    }

    void Cancel()
    {
		sg = null;
		this.setVisible(false);
    }

    void tabSelect(ChangeEvent e)
    {
		if (jTabbedPane1.getSelectedIndex() == this.jTabbedPane1.getTabCount()-1)
		{
			bNext.setText("Finish");
		}
		else
		{
			bNext.setText("Next");
		}
		bPrev.setEnabled(jTabbedPane1.getSelectedIndex() > 0);

		switch (this.jTabbedPane1.getSelectedIndex())
		{
			case 0:
			break;

			case 1:
				this.setSecondTab();
			break;
		}
    }

	void setSecondTab()
	{
		Ss =            DiscreteFunction.allPossible(this.states, this.messages);
		Sh =            DiscreteFunction.allPossible(this.messages, this.actions);
		FiniteSet Is =  FiniteSet.cartesianProduct(Ss, Sh);

		I =             Individual.getIndividuals(new FiniteSet(new Object [] {"default"}), Is);

		payoff_utility.setSets(this.states, this.actions);
		payoff_cost.setSets(this.states, this.messages);
		probability_state.setSets(this.states);
		probability_indiv.setSets(Is);
	}

    void prevTab(ActionEvent e)
    {
		jTabbedPane1.setSelectedIndex(jTabbedPane1.getSelectedIndex()-1);
    }

    void nextTab(ActionEvent e)
    {
		if (jTabbedPane1.getSelectedIndex() == this.jTabbedPane1.getTabCount()-1)
		{
			OK();
		}
		else
		{
		    jTabbedPane1.setSelectedIndex(jTabbedPane1.getSelectedIndex()+1);
		}
    }
}
