package math;



/** Models the standard mathematical ordered structure of elements.
 *  @author Project A.I. Development Team
 */

public class Tuple
{
	public final Object [] elements;

	/** Construct a new Tuple
	 *
	 * @param elements
	 */

	public Tuple(Object [] elements)
    {
		this.elements = elements;
    }

	/** Creates a one-line string represenation of this tuple using mathematical notation
	 *
	 * @return The string
	 */

	public String toString()
	{
		StringBuffer s = new StringBuffer();
		s.append('<');
		for (int i = 0; i < elements.length; i++)
		{
			if (i > 0) s.append(", ");
			s.append(elements[i]);
		}
		s.append('>');

		return s.toString();
	}

	public String multiline()
	{
		StringBuffer s = new StringBuffer();
		s.append("<\n");
		for (int i = 0; i < elements.length; i++)
		{
			if (i > 0) s.append("\n,\n");
			s.append(elements[i]);
		}
		s.append("\n>");

		return s.toString();
	}
}