package signalgame;

import math.ProbabilityDistribution;

public class ExchangeMutator implements Mutator
{

	public ProbabilityDistribution mutate(ProbabilityDistribution pd)
	{
		// Copy the probability function
		double [] r = new double[pd.ps.length];
		for (int i = 0; i < r.length; i++) r[i] = pd.ps[i];

		int source = (int)(Math.random()*r.length);
		int target = (int)(Math.random()*r.length);

		// How much probability can be transferred from source to target?
		// Until either - source is empty - target is full

		double exchange = Math.random() * Math.min(r[source], 1-r[target]);

		r[source] -= exchange;
		r[target] += exchange;

		return new ProbabilityDistribution(pd.domain, r);
	}

	public String toString()
	{
		return "Exchange Mutator";
	}
}