package signalgame;

import math.ProbabilityDistribution;



public class FairShareMutator implements Mutator
{
	double mutationRate;

	public FairShareMutator(double mutationRate)
	{
		this.mutationRate = mutationRate;
	}

	public ProbabilityDistribution mutate(ProbabilityDistribution pd)
	{
		double [] ps = new double [pd.ps.length];

		// Copy old
		for (int i = 0; i < ps.length; i++)
		{
			ps[i] = pd.ps[i];
		}

		// From every ps[i] we take a MUTATION'th part.
		// now we have MUTATION probability left.
		// This is divided evenly amongst all ps[i]s

		double fairshare = mutationRate/ps.length;
		double mutilate = 1-mutationRate;

		for (int i = 0; i < ps.length; i++)
		{
			ps[i] = ps[i] * mutilate + fairshare;
		}

		return new ProbabilityDistribution(pd.domain, ps);
	}

	public String toString()
	{
		return "FairShare (" + mutationRate + ") Mutator";
	}
}