package signalgame;

import math.ProbabilityDistribution;


public class RelativeDynamics implements Dynamics
{
	public ProbabilityDistribution evolve(double [] Ei, double E, ProbabilityDistribution Pi)
	{
		// There is no Utility, so the game doesn't evolve
		if (E == 0.0) return Pi;

		// Update probability based on Utility
		double [] ps = new double[Pi.domain.elements.length];
		for (int i = 0; i < ps.length; i++)
		{
			ps[i] = Pi.ps[i]*Ei[i]/E;
		}

		return new ProbabilityDistribution(Pi.domain, ps);
	}
}