package signalgame;

import math.*;


public class ReputationFunction
{
	public final    FiniteSet       domain;
	public final    Function []     fs;

    public ReputationFunction(FiniteSet domain, Function [] fs)
    {
		assert fs.length == domain.elements.length : "Number of functions " + fs.length + " should match number of reputations " + domain.elements.length;
		this.domain =   domain;
		this.fs =       fs;
    }

	public String multiline()
	{
		StringBuffer s = new StringBuffer();

		for (int i = 0; i < domain.elements.length; i++)
		{
			if (i != 0) s.append("\n");
			s.append(domain.elements[i] + ":\n");
			s.append(fs[i].multiline());
		}

		return s.toString();
	}

	public double distance(ReputationFunction R)
	{
		double d2 = 0;
		for (int i = 0; i < fs.length; i++)
		{
			double d = fs[i].distance(R.fs[i]);
			d2 += d*d;
		}
		return  Math.sqrt(d2);
	}
}