package signalgame;

import math.*;

/** The static information during the Signal Game Simulation
 */



public abstract class StaticInformation
{
	public final    FiniteSet                   T, M, A, R;
	public final	ProbabilityDistribution     Pt;
	public final	ReputationPayoffMatrix      Utilities;
	public final	ReputationPayoffMatrix      Costs;
	public final    Mutator                     mutator;
	public final    Dynamics                    dynamics;

    public StaticInformation(  FiniteSet T, FiniteSet M, FiniteSet A, FiniteSet R,
						ProbabilityDistribution Pt,
						ReputationPayoffMatrix Utilities, ReputationPayoffMatrix Costs,
						Mutator mutator)
    {
		this.T =            T;
		this.M =            M;
		this.A =            A;
		this.R =            R;
		this.Pt =           Pt;
		this.Utilities =    Utilities;
		this.Costs =        Costs;
		this.mutator =      mutator;
		this.dynamics =     new RelativeDynamics();
    }

	public abstract DynamicInformation createDyamic();
	public abstract String multiline();
}