package signalgame;

import math.*;

public class UnfairShareMutator implements Mutator
{
	double mutationRate;

	public UnfairShareMutator(double mutationRate)
	{
		this.mutationRate = mutationRate;
	}

	public ProbabilityDistribution mutate(ProbabilityDistribution pd)
	{
		double [] ps = new double [pd.ps.length];

		// Copy old
		for (int i = 0; i < ps.length; i++)
		{
			ps[i] = pd.ps[i];
		}

		// From every ps[i] we take a MUTATION'th part.
		// now we have MUTATION probability left.
		// This is given to a random element

		double mutilate = 1-mutationRate;

		for (int i = 0; i < ps.length; i++)
		{
			ps[i] = ps[i] * mutilate;
		}

		ps[(int)(Math.random()* ps.length)] += mutationRate;

		return new ProbabilityDistribution(pd.domain, ps);
	}

	public String toString()
	{
		return "UnfairShare (" + mutationRate + ") Mutator";
	}

}