package signalgame.instancebased;

import math.ProbabilisticFunction;
import signalgame.*;

public class Individual extends IIndividual
{
	public final IndividualType          type;

    public Individual(IndividualType type, ReputationFunction Ss, ReputationFunction Sh, int reputationID)
    {
		super(Ss, Sh, reputationID);
		for (int i = 0; i < Ss.fs.length; i++)  assert Ss.fs[i] instanceof ProbabilisticFunction;
		for (int i = 0; i < Sh.fs.length; i++)  assert Sh.fs[i] instanceof ProbabilisticFunction;

		this.type =         type;
    }

	public String multiline()
	{
		return "<\n" + Ss.multiline() + "\n,\n" + Sh.multiline() + "\n,\n" + reputationID + "\n>";
	}

	public double distance(Individual I)
	{
		double d1 = Ss.distance(I.Ss);
		double d2 = Sh.distance(I.Sh);
		return  Math.sqrt(d1*d1 + d2*d2);
	}
}