package signalgame.typebased;

import math.*;
import signalgame.*;


public class Individual extends IIndividual
{

    public Individual(ReputationFunction Ss, ReputationFunction Sh, int reputationID)
    {
		super(Ss, Sh, reputationID);
    }

	public String multiline()
	{
		return "<\n" + Ss.multiline() + "\n,\n" + Sh.multiline() + "\n>";
	}


	public String toString()
	{
		return multiline();
	}


	public static Individual [] getIndividuals(FiniteSet R, FiniteSet Is)
	{
		Individual [] I = new Individual [Is.elements.length];
		for (int i = 0; i < I.length; i++)
		{
			I[i] = new Individual( new ReputationFunction(R, new Function [] {(DiscreteFunction)((Tuple)Is.elements[i]).elements[0]}),
								   new ReputationFunction(R, new Function [] {(DiscreteFunction)((Tuple)Is.elements[i]).elements[1]}),
								   0);
		}
		return I;
	}

}